/*
 * Use trap.
 * See gdb/sim/m32r/traps.c:m32r_trap()
 * (case TRAP_SYSCALL :)
 * See gdb/sim/testsuite/m32r-elf/hello.s
 * See gdb/sim/testsuite/sim/m32r/hello.ms
 */

/* See gdb/sim/common/nltvals.def (NL_TARGET_m32r) */
#define SYS_exit  1
#define SYS_open  2
#define SYS_close 3
#define SYS_read  4
#define SYS_write 5

#define TRAP_SYSCALL 0

	.org	0x1af4

	.section .text

	.globl	_start
	.type	_start, @function
_start:
_fname:	.string	"pass.txt"
	.byte	0
	.byte	0
	.byte	0
	.long	0

	.long	1f

1:
__r_open:
	ld24	r1, _fname
	ldi	r2, #0 || nop
	ldi	r0, #SYS_open || nop
	trap	#TRAP_SYSCALL

__r_read:
	mv	r1, r0 || nop
	ld24	r2, _buffer
	ldi	r3, #32 || nop
	ldi	r0, #SYS_read
	trap	#TRAP_SYSCALL

__r_write:
	ldi	r1, #1 || nop
	ld24	r2, _buffer
	ldi	r3, #32 || nop
	ldi	r0, #SYS_write
	trap	#TRAP_SYSCALL

__r_exit:
	ldi	r1, #0 || nop
	ldi	r0, #SYS_exit
	trap	#TRAP_SYSCALL

_buffer:
