/*
 * Use reserved instruction.
 * See gdb/sim/mips/interp.c:signal_exception(),sim_monitor()
 * (ReservedInstruction)
 * Memory address is defined by K0BASE. (See gdb/sim/mips/interp.c)
 */

#define SYS_exit  17
#define SYS_open   6
#define SYS_read   7
#define SYS_write  8
#define SYS_close 10

#define RSVD_INSTRUCTION 0x00000005
#define RSVD(arg) ((((arg) << 1) << 6) | RSVD_INSTRUCTION)

/* #define EXIT_BY_SYSCALL */
/* #define EXIT_BY_BREAK */

#if 0
	.org	0x800006e0
#else
	.org	0x000006e0
#endif

	.section .text

	.globl	_start
	.type	_start, @function
_start:
_fname:	.string	"pass.txt"
	.byte	0
	.byte	0
	.byte	0
	.long	0

	.long	0
	.long	1f

1:
__open:
	lw	$a0, _fname_addr
	li	$a1, 0
	jal	_open_syscall
	nop

__read:
	move	$a0, $v0
	lw	$a1, _buffer_addr
	li	$a2, 32
	jal	_read_syscall
	nop

__write:
	li	$a0, 1
	lw	$a1, _buffer_addr
	li	$a2, 32
	jal	_write_syscall
	nop

__exit:
	li	$a0, 0
	jal	_exit_syscall
	nop

_open_syscall:
	.long	RSVD(SYS_open)
	jr	$ra
	nop

_read_syscall:
	.long	RSVD(SYS_read)
	jr	$ra
	nop

_write_syscall:
	.long	RSVD(SYS_write)
	jr	$ra
	nop

_exit_syscall:
	nop
#ifdef EXIT_BY_SYSCALL
	.long	RSVD(SYS_exit)
#elif defined(EXIT_BY_BREAK)
	/*
	 * To avoid exit message.
	 * (See gdb/sim/mips/mips.igen:break,HALT_INSTRUCTION)
	 */
	break	1023
#else /* 0x03ff000d is same as break 1023. */
	.long	0x03ff000d
#endif
	jr	$ra
	nop

_fname_addr:
	.long	_fname
_buffer_addr:
	.long	_buffer
_buffer:
